`timescale 1ns/1ps

module tb;


reg clk;

always #10 clk = ~clk;

reg [3:0] 	count;
reg [3:0] 	count_old; //debug

wire [3:0] 	adder_out;
wire		overflow;

adder_top UUT(
	.i_x(count),
	.i_y(1'b1),
	.o_out(adder_out),
	.o_overflow(overflow)
	);
	
initial begin
	clk 	  = 0;
	count 	  = 0;
	count_old = 15;
end

always @(posedge clk)   count <= adder_out;
    
always @(negedge clk) begin    
    //debug
    if ((count != count_old+1)&&(count_old != 15)) begin
        $display("ERROR found");
        $stop;
    end
    else begin
        count_old = count;   
    end

end

endmodule