module adder_top(
	input [3:0]		i_x,
	input [3:0] 	i_y,
	output [3:0] 	o_out,
	output 			o_overflow
);


wire sum_out_0;
wire sum_out_1;
wire sum_out_2;
wire sum_out_3;

wire c_out_0;
wire c_out_1;
wire c_out_2;
wire c_out_3;



full_adder FA_0(
	.in_x(i_x[0]),
	.in_y(i_y[0]),
	.carry_in(0),
	.sum_out(sum_out_0),
	.carry_out(c_out_0)
);
	
	
full_adder FA_1(
	.in_x(i_x[1]),
	.in_y(i_y[1]),
	.carry_in(c_out_0),
	.sum_out(sum_out_1),
	.carry_out(c_out_1)
);
	

full_adder FA_2(
	.in_x(i_x[2]),
	.in_y(i_y[2]),
	.carry_in(c_out_1),
	.sum_out(sum_out_2),
	.carry_out(c_out_2)
);
	
	
full_adder FA_3(
	.in_x(i_x[3]),
	.in_y(i_y[3]),
	.carry_in(c_out_2),
	.sum_out(sum_out_3),
	.carry_out(c_out_3)
);

assign o_overflow = c_out_3 ;
assign o_out = {sum_out_3,sum_out_2,sum_out_1,sum_out_0};






endmodule
